/*
 * rfm12b_slemi.h
 *
 *  Created on: 12. mar. 2018
 *      Author: Gregor
 */

#ifndef RFM12B_SLEMI_H_
#define RFM12B_SLEMI_H_

// RF12 command codesTODO change
#define RF_RX_ON  0x82DD
#define RF_TX_ON   0x823D
#define RF_IDLE_MODE    0x820D
#define RF_SLEEP_MODE   0x8205
#define RF_WAKEUP_MODE  0x8207
#define RF_TXREG_WRITE  0xB800
#define RF_RX_FIFO_READ 0xB000
#define RF_WAKEUP_TIMER 0xE000

#include "main.h"
#include "stm32l4xx_hal.h"

uint16_t rf12_write_cmd(uint16_t data);
void rf12_init(void);
void rf12_write_data(uint16_t data);
void FIFOReset(void);
unsigned char rfRecv();
unsigned char waitForData(void);

uint16_t rf12_write_cmd(uint16_t data)
{
	uint16_t return_d;
	uint8_t RxD[2], TxD[2];
	TxD[0] = data & 0xFF;
	TxD[1] = data >> 8;
	HAL_GPIO_WritePin(SPI1_nSEL_GPIO_Port, SPI1_nSEL_Pin, GPIO_PIN_RESET);
	HAL_SPI_TransmitReceive(&hspi1, TxD, RxD, 1, 100);
	HAL_GPIO_WritePin(SPI1_nSEL_GPIO_Port, SPI1_nSEL_Pin, GPIO_PIN_SET);
	return_d = RxD[1] << 8;
	return_d += RxD[0];

	return return_d;
}

void rf12_init(void)
{
	rf12_write_cmd(0x0000);
	rf12_write_cmd(0x80E8);
	rf12_write_cmd(RF_RX_ON);
	rf12_write_cmd(0xA680); //frq
	rf12_write_cmd(0xC647);
	rf12_write_cmd(0x94A2);
	rf12_write_cmd(0xC2AC);
	rf12_write_cmd(0xCA83);
	rf12_write_cmd(0xCED4);
	rf12_write_cmd(0xC483);
	rf12_write_cmd(0x9855);
	rf12_write_cmd(0xCC77);
	rf12_write_cmd(0xE000);
	rf12_write_cmd(0xC800);
	rf12_write_cmd(0xC049);
}

void rf12_write_data(uint16_t data)
{
	while (HAL_GPIO_ReadPin(SPI1_nIRQ_GPIO_Port, SPI1_nIRQ_Pin))
	{
	}
	rf12_write_cmd(0xB800 + data);
}

void FIFOReset(void)
{
	rf12_write_cmd(0xCA81);
	rf12_write_cmd(0xCA83);
}

unsigned char rfRecv()
{
	unsigned int data;
	while (1)
	{
		data = rf12_write_cmd(0x0000);
		if ((data & 0x8000))
		{
			data = rf12_write_cmd(0xB000);
			return (data & 0x00FF);
		}
	}
}

unsigned char waitForData(void)
{
	//SDO_LOW;
	HAL_GPIO_WritePin(SPI1_MOSI_GPIO_Port, SPI1_MOSI_Pin, GPIO_PIN_RESET);
	//nSEL_LOW;
	HAL_GPIO_WritePin(SPI1_nSEL_GPIO_Port, SPI1_nSEL_Pin, GPIO_PIN_RESET);
	//SCK_HIGH;
	HAL_GPIO_WritePin(SPI1_SCK_GPIO_Port, SPI1_SCK_Pin, GPIO_PIN_SET);
	//if(P1IN & BIT7)
	if (HAL_GPIO_ReadPin(SPI1_nIRQ_GPIO_Port, SPI1_nIRQ_Pin))
	{
		//SCK_LOW;
		HAL_GPIO_WritePin(SPI1_SCK_GPIO_Port, SPI1_SCK_Pin, GPIO_PIN_RESET);
		//SDO_HIGH;
		HAL_GPIO_WritePin(SPI1_MOSI_GPIO_Port, SPI1_MOSI_Pin, GPIO_PIN_SET);
		//nSEL_HIGH;
		HAL_GPIO_WritePin(SPI1_nSEL_GPIO_Port, SPI1_nSEL_Pin, GPIO_PIN_SET);
		return 1;
	}
	else
	{
		//SCK_LOW;
		HAL_GPIO_WritePin(SPI1_SCK_GPIO_Port, SPI1_SCK_Pin, GPIO_PIN_RESET);
		//SDO_HIGH;
		HAL_GPIO_WritePin(SPI1_MOSI_GPIO_Port, SPI1_MOSI_Pin, GPIO_PIN_SET);
		//nSEL_HIGH;
		HAL_GPIO_WritePin(SPI1_nSEL_GPIO_Port, SPI1_nSEL_Pin, GPIO_PIN_SET);
		return 0;
	}
}

#endif /* RFM12B_SLEMI_H_ */
